#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
//#include <GKlib.h>
#include <parmetis.h>
#include <mpi.h>


int main(int argc, char **argv)
{
    idx_t *part;
    int comm = MPI_COMM_WORLD;
    idx_t i, wgtflag, numflag, ncon, nparts, edgecut, options[10];
    real_t *tpwgts, ubvec;

    idx_t *M,*IA;

    int rank,size;
    idx_t nndcore;

    MPI_Datatype MPI_IDXTYPE = (sizeof(idx_t)==sizeof(long long))?MPI_LONG_LONG:MPI_INT;

    idx_t *nnods_biases;

    MPI_Init(&argc,&argv);
    MPI_Comm_rank(MPI_COMM_WORLD,&rank);
    MPI_Comm_size(MPI_COMM_WORLD,&size);

    {
        char fname[100];
        sprintf(fname,"test.%d",rank);
        {
            int i,j;
            int nndcore_in;
            int M_nndcore;
            FILE *fp = fopen(fname,"rb");
            fscanf(fp,"%d %d\n",&nndcore_in,&M_nndcore);
            nndcore = nndcore_in;
            M  = (idx_t*)malloc((nndcore+1)*sizeof(idx_t));
            IA = (idx_t*)malloc(M_nndcore  *sizeof(idx_t));
            M[0] = 0;
            for(i=0;i<nndcore;i++) {
                int MM;
                fscanf(fp,"%d\n",&MM);
                M[i+1] = MM;
                for(j=M[i];j<M[i+1];j++) {
                    int IAj;
                    fscanf(fp,"%d ",&IAj);
                    IA[j] = IAj;
                }
            }
            fclose(fp);
        }
    }

    part         = (idx_t*)malloc(nndcore*sizeof(idx_t));

    nnods_biases = (idx_t*)malloc(sizeof(idx_t)*(size+1));

    MPI_Allgather(&nndcore,1,MPI_IDXTYPE,nnods_biases,1,MPI_IDXTYPE,MPI_COMM_WORLD);

    {
        int ir;

        for(ir=size-1;0<=ir;ir--) { nnods_biases[ir+1] = nnods_biases[ir]; }
        nnods_biases[0]=0;
        for(ir=0;ir<size;ir++)    { nnods_biases[ir+1]+= nnods_biases[ir]; }
    }

    ncon    = 1;
    wgtflag = 0;
    numflag = 0;
    nparts  = size;
    ubvec   = 1.03;
    tpwgts = (real_t *)malloc(sizeof(real_t)*nparts);
    for (i=0; i<nparts; i++)
      tpwgts[i] = 1.0/nparts;
    options[0] = 1;
    options[1] = 15;
    options[2] = 1;

    ParMETIS_V3_PartKway(
                    nnods_biases,/*idx_t *vtxdist, */
                    M,          /*idx_t *xadj, */
                    IA,         /*idx_t *adjncy, */
                    NULL,       /*idx_t *vwgt,*/ 
                    NULL,       /*idx_t *adjwgt,*/ 
                    &wgtflag,   /*int *wgtflag, */
                    &numflag,   /*int *numflag,*/ 
                    &ncon,      /*int *ncon, */
                    &nparts,    /*int *nparts,*/ 
                    tpwgts,     /*float *tpwgts,*/ 
                    &ubvec,     /*float *ubvec,*/ 
                    options,    /*int *options, */
                    &edgecut,   /*int *edgecut, */
                    part,       /*idx_t *part, */
                    &comm      /*MPI_Comm *comm*/
            );

    free(tpwgts);
    free(IA);
    free(M);
    free(part);
    free(nnods_biases);

    MPI_Finalize();

    return 0;
}

